alphard-aws Cookbook
====================

This cookbook provides a resource wrapper for awscli command line tool (aws).
It also installs: 
- a definition that registers an ec2 instance to an elb
- a definition that adds tag to an ec2 instance
- a definition that deletes s3 buckets
- a ohai plugin helper that compute the ec2 region from ec2 placement zone availability.

## Requirements

- Ubuntu 14.04

### Chef

- Chef 12.0 or later

## Packages
- `ohai` - alphard-aws needs ohai to install the custom plugin ec2_region that compute automatically the ec2 region
- `poise-python` -  alphard-aws needs poise-python to install awscli

## Attributes

### General

- `['alphard']['aws']['user']` - the user used to install aws cli and run commands with
- `['alphard']['aws']['group']` - the group used to install aws cli and run commands with
- `['alphard']['aws']['access_key']` - the access key used for AWS_ACCESS_KEY_ID
- `['alphard']['aws']['secret_key']` - the secret key used for AWS_SECRET_ACCESS_KEY
- `['alphard']['aws']['region']` - the region used for AWS_DEFAULT_REGION
- `['alphard']['aws']['output']` - the output used for AWS_DEFAULT_OUTPUT
- `['alphard']['aws']['verbose']` - if true resource will display awscli command output and failure in console.

### Awscli

- `['alphard']['aws']['awscli']['version']` - the awscli version to install, upgrade or downgrade

### Cloudformation
- `['alphard']['aws']['cloudformation']['region']` - the awscli version to install, upgrade or downgrade
- `['alphard']['aws']['cloudformation']['stacks']['default']['template'] - the cloudformation stacks used by environment

Usage
-----
#### alphard-aws::default

Just include `alphard-aws` in your node's `run_list`:

```json
{
  "name":"my_node",
  "run_list": [
    "recipe[alphard-aws]"
  ]
}
```

## License

Copyright 2009-2016, Hydra Technologies, Inc

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

## Authors
- Frédéric Nowak - frederic.nowak@alphard.io
