define :s3_delete_buckets, :tags => nil, :access_key => nil, :secret_key => nil, :region => nil do

  # Defines variables
  tags = params[:tags]
  access_key = params['access_key']
  unless access_key
    access_key = node['alphard']['aws']['cloudformation']['access_key']
  end
  secret_key = params['secret_key']
  unless secret_key
    secret_key = node['alphard']['aws']['cloudformation']['secret_key']
  end
  region = params['region']
  unless region
    region = node['alphard']['aws']['cloudformation']['region']
  end

  # Creates tags
  ruby_block "delete s3 buckets with tags: #{tags}" do
    block do
      require 'colorize'
      require 'json'

      ENV['AWS_ACCESS_KEY_ID'] = access_key
      ENV['AWS_SECRET_ACCESS_KEY'] = secret_key
      ENV['AWS_DEFAULT_REGION'] = region

      def aws(command)
        full_command = "aws #{command}"
        Chef::Log.info "execute: #{full_command}"
        output = %x(#{full_command} 2>&1).strip
        exit_code = $?.exitstatus
        if exit_code > 0
          raise output
        else
          return output
        end
      end

      def delete_objects(bucket)
        def ls(bucket)
          json = aws("s3api list-object-versions --bucket #{bucket}")
          out = JSON.parse(json)
          truncated = out['IsTruncated']
          objects = (out['DeleteMarkers'] + out['Versions']).map { |entry|
            {:Key => entry['Key'], :VersionId => entry['VersionId']}
          }
          return truncated, objects
        end
        def del(bucket, objects)
          if objects.length != 0
            json = JSON.generate({:Objects => objects, :Quiet => false})
            aws("s3api delete-objects --bucket #{bucket} --delete '#{json}'")
          end
        end
        truncated = true
        while truncated do
          truncated, objects = ls(region, bucket)
          del(region, bucket, objects)
        end
      end

      bucket_list = aws('s3 ls')
      bucket_list.lines.each { |line|
        begin
          bucket = line.split(' ')[2]
          bucket_tags = aws("s3api get-bucket-tagging --bucket #{bucket}")
          bucket_tags_set = JSON.parse(bucket_tags)['TagSet']
          if tags && bucket_tags_set
            bucket_delete = false
            bucket_tags_set.each { |tag|
              bucket_tag_key = tag['Key']
              bucket_tag_value = tag['Value']
              bucket_delete = tags[bucket_tag_key] == bucket_tag_value
              if bucket_delete
                break
              end
            }
            if bucket_delete
              puts "\n\n    - delete bucket #{bucket}\n".green
              delete_objects(bucket)
              aws("s3 rb s3://#{bucket}")
            end
          end
        rescue Exception => _
        end
      }
    end
    action :run
  end

end