#
# Author:: Frédéric Nowak (<frederic.nowak@alphard.io>)
# Cookbook Name:: alphard-aws
# Attribute:: ec2_region
#
# Copyright 2011, Hydra Technologies, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

Ohai.plugin(:Ec2Region) do
  provides 'ec2_region'

  depends 'ec2'

  collect_data do
    if ec2 != nil
      Ohai::Log.debug('ec2_metadata_from_hints is present.')
      ec2_region /(?<region>.*)[a-z]/.match(ec2['placement_availability_zone'])[:region]
    else
      Ohai::Log.debug('No hints present for ec2. No region computed using default region.')
      ec2_region node['alphard']['aws']['region']
    end
  end

end